# # Section 18.5 Question 2

abc = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
def encode(text, key):
    """Encode text using Vigenere cyper.
        text contains only uppercase letters."""
    len_key = len(key)
    code = ''
    k = 0
    
    for c in text:
        i = abc.find(c)
        j = abc.find(key[k])
        c = abc[(i + j) % 26]
        code += c
        k = (k + 1) % len_key
        
    return code

def decode(code, key):
    """Decode code encoded with Vigenere cyper."""
    len_key = len(key)
    text = ''
    k = 0

    for c in code:
        i = abc.find(c)
        j = abc.find(key[k])
        c = abc[(i - j) % 26]
        text += c
        k = (k + 1) % len_key

    return text

key = 'LEMON'
text = 'ATTACKATDAWN'

print('<' + text + '>')
code = encode(text, key)
print('<' + code + '>')
text = decode(code, key)
print('<' + text + '>')
