from turtle import *

def draw_rectangle(t, w, h):
    """Draw a rectangle of width w and height h using the turtle t
       going counterclockwise, from its current position and direction,
       and in its current color. Leave the turtle with its pen up.
    """
    t.pendown()
    t.forward(w)
    t.left(90)
    t.forward(h)
    t.left(90)
    t.forward(w)
    t.left(90)
    t.forward(h)
    t.left(90)
    t.penup()    
    
# Section 9.2 Question 1

def q2_1():
    for k in (1, 2, 3, 4):
        forward(60)
        left(90)

    penup()
    for k in (1, 2):
        forward(20)
        left(90)
        pendown()
        forward(60)
        penup()
        backward(60)
        right(90)

    back(40)
    left(90)
    for k in (1, 2):
        forward(20)
        right(90)
        pendown()
        forward(60)
        penup()
        backward(60)
        left(90)


# Section 9.2 Question 3

# 3-a
def draw_hexagon(a):
    """Draw a hexagon with a given side a; return to the center."""
    penup()
    backward(a)
    right(60)
    pendown()
    for k in range(6):
        forward(a)
        left(60)
    penup()
    left(60)
    forward(a)

def q2_3b():
    shape('turtle')
    showturtle()
    color('blue')
    draw_hexagon(100)
    color('red')
    draw_hexagon(80)
    color('green')
    draw_hexagon(60)
    color('black')

# Section 9.3 Question 1

def q3_1():
    pensize(10)
    penup()
    for k in (1, 2, 3):
        goto(0, 20*k)
        pendown()
        forward(60)
        penup()

# Section 9.3 Question 3

def q3_3():
    a = 20
    
       # Draw the grid:

    for y in range(4):
        penup()
        goto(0, y*a)
        pendown()
        forward(7*a)
    left(90)
    for x in range(8):
        penup()
        goto(x*a, 0)
        pendown()
        forward(3*a)
    penup()

       # Draw the tokens:

    for x, y in ((1, 2), (3, 1), (5, 0)):
        goto(x*a + a/2, y*a + a/2)
        dot(a - 5)
        color('white')
        dot(a - 10)
        color('black')

# Section 9.3 Question 6

def q3_6():
    a = 40

        # Draw the octagon:

    color('black', 'red')
    penup()
    goto(-a, -a/2)
    #pensize(2)
    pendown()
    begin_fill()
    for k in range(8):
        forward(a)
        left(45)
    end_fill()

        # Draw STOP:

    penup()
    color('white')
    goto(-1.4*a, 0.3*a)
    write('STOP', font=('Arial', a//2, 'bold'))

# Section 9.3 Question 8

def q3_8():
    y0 = -200
    scale = 40

        # Draw the axes:

    penup()
    goto(0, y0-20)
    pendown()
    goto(0, y0+400)
    penup()
    goto(-4*scale, y0)
    pendown()
    goto(4*scale, y0)
    penup()

        # Draw the papabola:
        
    x = -3
    goto(x*scale, y0 + x*x*scale)
    x += 0.1
    pendown()
    while x < 3.1:
        goto(x*scale, y0 + x*x*scale)
        x += 0.1
    penup()

        # Draw the label:

    goto(3*scale, 90)
    write('y = x', font=('Times', 25, 'italic'), move=True)
    goto(xcor()+3, ycor()+15)
    write('2', font=('Times', 15))

# Section 9.4 Question 5

def q4_5():

    def draw_square(x, y, a, c):
        """Draw a square at a given position, side a, color c."""
        color(c)
        goto(x - a/2, y - a/2)
        pendown()
        begin_fill()
        goto(x + a/2, y - a/2)
        goto(x + a/2, y + a/2)
        goto(x - a/2, y + a/2)
        goto(x - a/2, y - a/2)
        end_fill()
        penup()
        
    Screen().colormode(255)
    v = (255, 127, 0)
    for r in range(3):
        for g in range(3):
            for b in range(3):
                draw_square(80*r + 20*b, -20*g, 20, (v[r], v[g], v[b]))

from time import sleep

for q in (q2_1, q2_3b, q3_1, q3_3, q3_6, q3_8, q4_5):
    Screen().clear(); speed('fastest'); hideturtle()
    q()
    sleep(2)
